unit hiPIPEServer;

interface

uses Kol,Share,Windows,Debug;

const
  IN_BUF_SIZE = MAXWORD;
  OUT_BUF_SIZE = MAXWORD;
  TIME_OUT = 0;
  MAX_READ = MAXWORD;
  MAX_PIPE_INSTANCES = 100;
  NAME_SIZE = 25;
  LINE_LEN = 80;

type
  THIPIPEServer = class(TDebug)
   private
    hPipe:cardinal;
    lol:string;
    th:PThread;
    s,str:string;

    function _OnExec(Sender:PThread):Integer;
    procedure Stop;
    procedure SyncExec;
   public
    _prop_Name:string;
    _data_Name:THI_Event;

    _event_onStatus:THI_Event;
    _event_onRead:THI_Event;

    destructor Destroy; override;
    procedure _work_doCreate(var _Data:TData; Index:word);
    procedure _work_doDestroy(var _Data:TData; Index:word);
  end;

implementation

destructor THIPIPEServer.Destroy;
begin
   Stop;
   inherited;
end;

procedure THIPIPEServer._work_doCreate;
begin
   if not Assigned(th) then begin
      lol:= ReadString(_Data,_data_Name,_prop_Name);
      hPipe := CreateNamedPipe(PChar('\\.\PIPE\'+lol), //   = 'test'.
               PIPE_ACCESS_INBOUND// or     //   -
//               PIPE_ACCESS_DUPLEX or      //  
//               FILE_FLAG_OVERLAPPED,      //  -
               ,PIPE_WAIT or               //  
               PIPE_READMODE_BYTE or      //      
               PIPE_TYPE_BYTE,
               MAX_PIPE_INSTANCES,        //    .
               OUT_BUF_SIZE,              //   /.
               IN_BUF_SIZE,
               TIME_OUT,                  // -.
               nil);                      //  .

      if hPipe = INVALID_HANDLE_VALUE then
         _hi_OnEvent(_event_onStatus,0)
      else begin
         _hi_OnEvent(_event_onStatus,1);
         SetLength(str,MAXWORD);
         {$ifdef F_P}
         th := NewThreadforFPC;
         {$else}
         th := NewThread;
         {$endif}
         th.OnExecute := _OnExec;
         th.Resume;
      end;
   end;
end;

function THIPIPEServer._OnExec;
var   nBytesRead:cardinal;
begin
   while not Sender.Terminated do begin
      ConnectNamedPipe(hPipe, nil);
      s := '';
      repeat
         if ReadFile(hPipe, str[1], MAXWORD, nBytesRead, nil) then begin
            SetLength(str,nBytesRead);
            s := s + str;
            SetLength(str,MAXWORD);
         end;   
      until nBytesRead = 0;
      if s <> '' then Sender.Synchronize(SyncExec);
   end;
   Result := 0;
end;

procedure THIPIPEServer.SyncExec;
begin
   _hi_OnEvent(_event_onRead,s);
end;

procedure THIPIPEServer.Stop;
begin
   if th <> nil then begin
      CloseHandle(hPipe);
      th.Free;
      th := nil;
   end;
end;

procedure THIPIPEServer._work_doDestroy;
begin
   Stop;
end;

end.
